# Description file for VMSTAR.

# Xmu include files
# X11XMU=X11LIB:
X11XMU=sys$sysroot:[decw$include.xmu]

# Xmu library to use
# X11XMULIB=X11LIB:XMU.OLB
X11XMULIB=SYS$SHARE:DECW$XMULIBSHR/SHARE

# xpm object library directory
XPMLIB=pd:[src.xpm-3_4e]

# ctwm exit style:
#	0 - Just exit with error code 20.
#	1 - run sys$system:decw$endsession.exe on exit
EXIT_ENDSESSION = 0

#------------------------- End of customization -----------------------------

MORE_CFLAGS = /DEBUG/DEFINE=(VMS,XPM,C_ALLOCA,""""emacs"""",BLOCK_INPUT,EXIT_ENDSESSION=$(EXIT_ENDSESSION)''extra_defs')

LD = link
#LDFLAGS = /DEBUG
LDFLAGS = /NOTRACE

# if you want to put the executable and object files at some specific place,
# change this macro
GOAL=

# All the files we distribute
DISTFILES = readme.* changes. *.txt *.doc *.*mms imakefile.* *.com *.c *.c_vms *.h *.h_vms *.y *.l *.ctwmrc *.*orig *.bm [.xpm]*.*

# Some files we distribute in the source-only archive
SRCDISTEXTRA = *.*diff

# Some files we distribute in the .zip archive file.
ZIPDISTEXTRA = *.*_obj

all : setup
	$(MMS) $(MMSQUALIFIERS) /DESCRIPTION=DESCRIP.SUBMMS -
		/MACRO=(X11XMU=$(X11XMU),XPMLIB=$(XPMLIB),CFLAGS="''all_cflags'",LD="$(LD)",LDFLAGS="$(LDFLAGS)",GOAL="$(GOAL)",CLIB="''clib'",X11XMULIB="$(X11XMULIB)",EXT="''ext'",EXE_EXT="''exe_ext'"'do_option''dep_xwdfile')

setup : version.opt xwdfile.h
	__axp = f$getsyi("HW_MODEL") .ge. 1024
	__tmp = f$edit("$(CFLAGS)","UPCASE")
	__decc = f$search("SYS$SYSTEM:DECC$COMPILER.EXE") .nes. "" -
		.and. __tmp - "/VAXC" .eqs. __tmp
	ext = "VAX_"
	if __axp then ext = "AXP_"
	exe_ext = ext
	if .not. __decc then ext = ext + "VAXC_"
	opt_ext = "DECC_OPT"
	if .not. __decc then opt_ext = "VAXC_OPT"
	clib = ""
	if .not. __decc then clib = "SYS$SHARE:VAXCRTL/SHARE"
	extra_defs = ""
	if .not. __decc then extra_defs = extra_defs + ",NO_LOCALE"
	if f$search("XWDFILE.H") .nes. "" then -
		extra_defs = extra_defs + ",HAVE_XWDFILE_H"
	dep_xwdfile = ""
	if extra_defs - ",HAVE_XWDFILE_H" .nes. extra_defs then -
		dep_xwdfile = ",DEP_XWDFILE=""XWDFILE.H"""
	all_cflags = "$(CFLAGS)$(MORE_CFLAGS)"
	do_option = ",OPTION=""$(GOAL)CTWM.''opt_ext'"",OPTIONCMD="",$(GOAL)CTWM.''opt_ext'/OPT"""
	if __decc then all_cflags = "/DECC/PREFIX=ALL " + all_cflags
	if __decc .and. __axp then all_cflags = all_cflags + "/L_DOUBLE=64"

xwdfile.h : descrip.mms
	@ ! This is a pure hack to circumvent a bug in the file provided by
	@ ! Digital.  This is so ugly we don't want the user to see what
	@ ! really happens.
	@ ! But perhaps we'll give him just a little hint, huh?  :-)
	@ write sys$output "Doing some hackery with XWDFile.h...  Sit tight"
	@ __result := NO
	@ if f$search("DECW$UTILS:XWDFILE.H") .nes. "" then __result := YES
	@ if __result then open/write foo xwdfile.tpu_tmp
	@ if __result then write foo -
		"input_file:=GET_INFO(COMMAND_LINE, ""file_name"");"
	@ if __result then write foo -
		"main_buffer := CREATE_BUFFER (""main"", input_file);"
	@ if __result then write foo -
		"position (beginning_of (main_buffer));"
	@ if __result then write foo -
		"loop"
	@ if __result then write foo -
		"	r := search_quietly (""""""copyright.h"""""", FORWARD);"
	@ if __result then write foo -
		"	EXITIF r = 0;"
	@ if __result then write foo -
		"	if beginning_of(r) <> end_of(r)"
	@ if __result then write foo -
		"	then"
	@ if __result then write foo -
		"		erase (r);"
	@ if __result then write foo -
		"		position (r);"
	@ if __result then write foo -
		"		copy_text (""<decw$utils/copyright.h>"");"
	@ if __result then write foo -
		"	endif;"
	@ if __result then write foo -
		"	position (end_of (r));"
	@ if __result then write foo -
		"endloop;"
	@ if __result then write foo -
		"position (beginning_of (main_buffer));"
	@ if __result then write foo -
		"loop"
	@ if __result then write foo -
		"	r := search_quietly (LINE_BEGIN + ""struct {"", FORWARD);"
	@ if __result then write foo -
		"	EXITIF r = 0;"
	@ if __result then write foo -
		"	if beginning_of(r) <> end_of(r)"
	@ if __result then write foo -
		"	then"
	@ if __result then write foo -
		"		erase (r);"
	@ if __result then write foo -
		"		position (r);"
	@ if __result then write foo -
		"		copy_text (""typedef struct {"");"
	@ if __result then write foo -
		"	endif;"
	@ if __result then write foo -
		"	position (end_of (r));"
	@ if __result then write foo -
		"endloop;"
	@ if __result then write foo -
		"write_file(main_buffer, get_info (command_line, ""output_file""));"
	@ if __result then write foo "quit;"
	@ if __result then close foo
	@ if __result then save_mesg = f$environment("MESSAGE")
	@ !if __result then -
	!	set message/nofacility/noidentification/noseverity/notext
	@ if __result then edit/tpu/nosection/nodisplay -
		/command=xwdfile.tpu_tmp/out=xwdfile.h -
		decw$utils:xwdfile.h
	@ if __result then delete xwdfile.tpu_tmp;*
	@ if __result then set message'save_mesg'
	@ if __result then write sys$output "There, done."

!ctwm.hlp : ctwm.rnh
!	runoff ctwm.rnh

mostlyclean :
	- delete/log *.*_obj;*
	- delete/log *.*_opt;*,*.opt;*
	- purge/log

clean : mostlyclean
	- delete/log *.*_exe;*
	- delete/log *.hlp;*
	- delete/log zip.*;*

dist_tar : setup renamefiles versions FRC
	- tar -cvf ctwm'vmsver'-src.tar $(DISTFILES) $(SRCDISTEXTRA)

dist_zip : renamefiles versions zip.comment-link FRC
	- define/user sys$input zip.comment-link
	- define/user sys$output zip.log
	- zip -"Vz" ctwm'vmsver'.zip $(DISTFILES) $(ZIPDISTEXTRA)

zip_src : renamefiles versions zip.comment FRC
	- define/user sys$input zip.comment
	- define/user sys$output zip.log
	- zip -"z" ctwm'vmsver'-src.zip $(DISTFILES) $(SRCDISTEXTRA)

renamefiles : LEX.C_VMS GRAM.C_VMS GRAM.H_VMS
	- purge LEX.C
	- rename LEX.C LEX.C_VMS
	- purge LEX.C_VMS
	- purge GRAM.C
	- rename GRAM.C GRAM.C_VMS
	- purge GRAM.C_VMS
	- purge GRAM.H
	- rename GRAM.H GRAM.H_VMS
	- purge GRAM.H_VMS
	- delete XWDFILE.H;*
	- purge XPM.H
	- rename XPM.H XPM.H_NODIST

version.opt : version.c descrip.mms
	@ sear version.c "*VersionNumber"/out=version.tmp
	@- open/read foo version.tmp
	@- read foo line
	@- close foo
	@- delete version.tmp;*
	@ version = f$extract(0,10,f$element(1,"""",line))
	open/write foo version.opt
	write foo "NAME=""CTWM"""
	write foo "IDENT=""V''version'"""
	close foo

versions : version.opt FRC
	@- open/read foo version.opt
	@- read foo line		! the name
	@- read foo line		! the ident
	@- close foo
	@ version = f$extract(1,10,f$element(1,"""",line))
	major = f$element(0,".",version)
	minor = f$element(0,"-",f$element(1,".",version))
	update = f$element(0," ",f$element(1,"-",version))
	testword = f$element(1," ",version)
	vmsver = "0''major'''minor'"
	if major .gt. 9 then vmsver = "''major'''minor'"
	if update .nes. "-" then vmsver = "U''update'"+vmsver
	if testword .nes. " " then vmsver = vmsver+"-"+testword
	
zip.comment : versions descrip.mms
	- open/write foo zip.comment
	- write foo ""
	- write foo "CTWM ''version' -- Read and write UN*X tar files under VMS"
	- write foo ""
	- write foo "Runs on both OpenVMS/VAX and OpenVMS/AXP."
	- write foo ""
	- close foo

zip.comment-link : versions descrip.mms
	- open/write foo zip.comment-link
	- write foo ""
	- write foo "CTWM ''version' -- Read and write UN*X tar files under VMS"
	- write foo ""
	- write foo "Runs on both OpenVMS/VAX and OpenVMS/AXP."
	- write foo ""
	- write foo "To get the executable, just do @LINK after you extracted"
	- write foo "the files, then follow the installation instructions in"
	- write foo "README.VMS."
	- write foo ""
	- close foo

FRC :
	@ ! This clause is to force other clauses to happen.
